Index: branches/new_class_id/src/lib/network/converter.cc
===================================================================
--- branches/new_class_id/src/lib/network/converter.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/converter.cc	(revision 9690)
@@ -28,5 +28,5 @@
 SHELL_COMMAND_STATIC(debug, Converter, Converter::debug);
 
-
+NewObjectListDefinition(Converter);
 /* using namespace std is default, this needs to be here */
 
Index: branches/new_class_id/src/lib/network/converter.h
===================================================================
--- branches/new_class_id/src/lib/network/converter.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/converter.h	(revision 9690)
@@ -24,4 +24,5 @@
 class Converter : public BaseObject
 {
+  NewObjectListDeclaration(Converter);
   public:
     static byte* intToByteArray(int x);
Index: branches/new_class_id/src/lib/network/data_stream.cc
===================================================================
--- branches/new_class_id/src/lib/network/data_stream.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/data_stream.cc	(revision 9690)
@@ -20,6 +20,5 @@
 /* using namespace std is default, this needs to be here */
 
-
-
+NewObjectListDefinition(DataStream);
 
 /**
Index: branches/new_class_id/src/lib/network/data_stream.h
===================================================================
--- branches/new_class_id/src/lib/network/data_stream.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/data_stream.h	(revision 9690)
@@ -17,5 +17,6 @@
 class DataStream : public BaseObject
 {
-      public:
+  NewObjectListDeclaration(DataStream);
+  public:
       DataStream();
       DataStream(DataStream& inStream, DataStream& outStream);
Index: branches/new_class_id/src/lib/network/handshake.cc
===================================================================
--- branches/new_class_id/src/lib/network/handshake.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/handshake.cc	(revision 9690)
@@ -23,5 +23,5 @@
 
 
-
+NewObjectListDefinition(Handshake);
 
 
Index: branches/new_class_id/src/lib/network/handshake.h
===================================================================
--- branches/new_class_id/src/lib/network/handshake.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/handshake.h	(revision 9690)
@@ -42,5 +42,5 @@
 class Handshake : public Synchronizeable
 {
-
+  NewObjectListDeclaration(Handshake);
   public:
     Handshake( int nodeType, int clientId = 0, int networkGameManagerId = 0, int messageManagerId = 0 );
Index: branches/new_class_id/src/lib/network/message_manager.cc
===================================================================
--- branches/new_class_id/src/lib/network/message_manager.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/message_manager.cc	(revision 9690)
@@ -28,5 +28,5 @@
 
 
-
+NewObjectListDefinition(MessageManager);
 MessageManager* MessageManager::singletonRef = NULL;
 
Index: branches/new_class_id/src/lib/network/message_manager.h
===================================================================
--- branches/new_class_id/src/lib/network/message_manager.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/message_manager.h	(revision 9690)
@@ -96,5 +96,5 @@
 class MessageManager : public Synchronizeable {
 
-
+  NewObjectListDeclaration(MessageManager);
  public:
    inline static MessageManager * getInstance(){ if (!singletonRef) singletonRef = new MessageManager();  return singletonRef; }
Index: branches/new_class_id/src/lib/network/monitor/connection_monitor.cc
===================================================================
--- branches/new_class_id/src/lib/network/monitor/connection_monitor.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/monitor/connection_monitor.cc	(revision 9690)
@@ -23,5 +23,5 @@
 /* using namespace std is default, this needs to be here */
 
-
+NewObjectListDefinition(ConnectionMonitor);
 /**
  * constructor
Index: branches/new_class_id/src/lib/network/monitor/connection_monitor.h
===================================================================
--- branches/new_class_id/src/lib/network/monitor/connection_monitor.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/monitor/connection_monitor.h	(revision 9690)
@@ -19,4 +19,5 @@
 class ConnectionMonitor : virtual public BaseObject
 {
+  NewObjectListDeclaration(ConnectionMonitor);
   public:
     ConnectionMonitor( int userId );
Index: branches/new_class_id/src/lib/network/monitor/network_monitor.cc
===================================================================
--- branches/new_class_id/src/lib/network/monitor/network_monitor.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/monitor/network_monitor.cc	(revision 9690)
@@ -37,4 +37,5 @@
 SHELL_COMMAND(debug, NetworkMonitor, debug);
 
+NewObjectListDefinition(NetworkMonitor);
 
 
Index: branches/new_class_id/src/lib/network/monitor/network_monitor.h
===================================================================
--- branches/new_class_id/src/lib/network/monitor/network_monitor.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/monitor/network_monitor.h	(revision 9690)
@@ -27,5 +27,5 @@
 class NetworkMonitor : public Synchronizeable
 {
-
+  NewObjectListDeclaration(NetworkMonitor);
   public:
     NetworkMonitor(NetworkStream* networkStream);
Index: branches/new_class_id/src/lib/network/monitor/network_stats_widget.cc
===================================================================
--- branches/new_class_id/src/lib/network/monitor/network_stats_widget.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/monitor/network_stats_widget.cc	(revision 9690)
@@ -30,4 +30,5 @@
 // ->setAlias("ProxyGui");
 
+NewObjectListDefinition(NetworkStatsWidget);
 
 HostWidget::HostWidget(const std::string& name, const IP& ip)
Index: branches/new_class_id/src/lib/network/monitor/network_stats_widget.h
===================================================================
--- branches/new_class_id/src/lib/network/monitor/network_stats_widget.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/monitor/network_stats_widget.h	(revision 9690)
@@ -20,4 +20,5 @@
 class HostWidget : public OrxGui::GLGuiBox
 {
+  NewObjectListDeclaration(HostWidget);
   public:
     HostWidget(const std::string& name, const IP& ip);
Index: branches/new_class_id/src/lib/network/network_game_manager.cc
===================================================================
--- branches/new_class_id/src/lib/network/network_game_manager.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/network_game_manager.cc	(revision 9690)
@@ -47,5 +47,5 @@
 
 
-
+NewObjectListDefinition(NetworkGameManager);
 NetworkGameManager* NetworkGameManager::singletonRef = NULL;
 
Index: branches/new_class_id/src/lib/network/network_game_manager.h
===================================================================
--- branches/new_class_id/src/lib/network/network_game_manager.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/network_game_manager.h	(revision 9690)
@@ -33,5 +33,5 @@
 class NetworkGameManager: public Synchronizeable
 {
-
+  NewObjectListDeclaration(NetworkGameManager);
   public:
     virtual ~NetworkGameManager();
Index: branches/new_class_id/src/lib/network/network_log.h
===================================================================
--- branches/new_class_id/src/lib/network/network_log.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/network_log.h	(revision 9690)
@@ -38,5 +38,4 @@
 class NetworkLog
 {
-
   public:
     virtual ~NetworkLog(void);
Index: branches/new_class_id/src/lib/network/network_manager.cc
===================================================================
--- branches/new_class_id/src/lib/network/network_manager.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/network_manager.cc	(revision 9690)
@@ -41,5 +41,5 @@
 
 
-
+NewObjectListDefinition(NetworkManager);
 NetworkManager* NetworkManager::singletonRef = NULL;
 
Index: branches/new_class_id/src/lib/network/network_manager.h
===================================================================
--- branches/new_class_id/src/lib/network/network_manager.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/network_manager.h	(revision 9690)
@@ -25,5 +25,5 @@
 class NetworkManager : public BaseObject
 {
-
+  NewObjectListDeclaration(NetworkManager);
   public:
 
Index: branches/new_class_id/src/lib/network/network_protocol.cc
===================================================================
--- branches/new_class_id/src/lib/network/network_protocol.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/network_protocol.cc	(revision 9690)
@@ -35,5 +35,5 @@
 
 
-
+NewObjectListDefinition(NetworkManager);
 /**
   standard constructor
Index: branches/new_class_id/src/lib/network/network_protocol.h
===================================================================
--- branches/new_class_id/src/lib/network/network_protocol.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/network_protocol.h	(revision 9690)
@@ -25,4 +25,5 @@
 class NetworkProtocol : virtual public BaseObject
 {
+  NewObjectListDeclaration(NetworkProtocol);
   public:
     NetworkProtocol();
Index: branches/new_class_id/src/lib/network/network_socket.cc
===================================================================
--- branches/new_class_id/src/lib/network/network_socket.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/network_socket.cc	(revision 9690)
@@ -24,7 +24,5 @@
 #include "network_socket.h"
 
-/* header for debug output */
-#include "debug.h"
-
+NewObjectListDefinition(NetworkSocket);
 /**
  * Default constructor
Index: branches/new_class_id/src/lib/network/network_socket.h
===================================================================
--- branches/new_class_id/src/lib/network/network_socket.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/network_socket.h	(revision 9690)
@@ -17,4 +17,5 @@
 class NetworkSocket : public BaseObject
 {
+  NewObjectListDeclaration(NetworkSocket);
   public:
     NetworkSocket();
Index: branches/new_class_id/src/lib/network/network_stream.cc
===================================================================
--- branches/new_class_id/src/lib/network/network_stream.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/network_stream.cc	(revision 9690)
@@ -57,5 +57,5 @@
 #define PACKAGE_SIZE  256
 
-
+NewObjectListDefinition(NetworkStream);
 /**
  * empty constructor
Index: branches/new_class_id/src/lib/network/network_stream.h
===================================================================
--- branches/new_class_id/src/lib/network/network_stream.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/network_stream.h	(revision 9690)
@@ -33,5 +33,5 @@
 class NetworkStream : public DataStream
 {
-
+  NewObjectListDeclaration(NetworkStream);
   public:
     NetworkStream();
Index: branches/new_class_id/src/lib/network/player_stats.cc
===================================================================
--- branches/new_class_id/src/lib/network/player_stats.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/player_stats.cc	(revision 9690)
@@ -30,7 +30,8 @@
 #include "shell_command.h"
 
+#include "class_id.h"
 
 CREATE_FACTORY(PlayerStats, CL_PLAYER_STATS);
-
+NewObjectListDefinitionID(PlayerStats, CL_PLAYER_STATS);
 
 /**
Index: branches/new_class_id/src/lib/network/player_stats.h
===================================================================
--- branches/new_class_id/src/lib/network/player_stats.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/player_stats.h	(revision 9690)
@@ -36,5 +36,5 @@
 class PlayerStats : public Synchronizeable
 {
-
+  NewObjectListDeclaration(PlayerStats);
   public:
     PlayerStats( const TiXmlElement* root = NULL );
Index: branches/new_class_id/src/lib/network/proxy/network_settings.cc
===================================================================
--- branches/new_class_id/src/lib/network/proxy/network_settings.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/proxy/network_settings.cc	(revision 9690)
@@ -27,4 +27,5 @@
 
 
+NewObjectListDefinition(NetworkSettings);
 
 NetworkSettings* NetworkSettings::singletonRef = NULL;
Index: branches/new_class_id/src/lib/network/proxy/network_settings.h
===================================================================
--- branches/new_class_id/src/lib/network/proxy/network_settings.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/proxy/network_settings.h	(revision 9690)
@@ -24,5 +24,5 @@
 class NetworkSettings : public BaseObject
 {
-
+  NewObjectListDeclaration(NetworkSettings);
   public:
     inline static NetworkSettings* getInstance() { if (!NetworkSettings::singletonRef) NetworkSettings::singletonRef = new NetworkSettings();
Index: branches/new_class_id/src/lib/network/proxy/proxy_control.cc
===================================================================
--- branches/new_class_id/src/lib/network/proxy/proxy_control.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/proxy/proxy_control.cc	(revision 9690)
@@ -41,4 +41,5 @@
 
 SHELL_COMMAND(forceReconnect, ProxyControl, forceReconnectionShell);
+NewObjectListDefinition(ProxyControl);
 
 /**
Index: branches/new_class_id/src/lib/network/proxy/proxy_control.h
===================================================================
--- branches/new_class_id/src/lib/network/proxy/proxy_control.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/proxy/proxy_control.h	(revision 9690)
@@ -30,5 +30,5 @@
 class ProxyControl : public Synchronizeable
 {
-
+  NewObjectListDeclaration(ProxyControl);
   public:
     inline static ProxyControl* getInstance() { if (!ProxyControl::singletonRef) ProxyControl::singletonRef = new ProxyControl();
Index: branches/new_class_id/src/lib/network/server_socket.cc
===================================================================
--- branches/new_class_id/src/lib/network/server_socket.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/server_socket.cc	(revision 9690)
@@ -23,8 +23,5 @@
 #include "server_socket.h"
 
-/* header for debug output */
-#include "debug.h"
-
-
+NewObjectListDefinition(ServerSocket);
 /**
  * constructor
Index: branches/new_class_id/src/lib/network/server_socket.h
===================================================================
--- branches/new_class_id/src/lib/network/server_socket.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/server_socket.h	(revision 9690)
@@ -19,4 +19,5 @@
 class ServerSocket : public BaseObject
 {
+  NewObjectListDeclaration(ServerSocket);
   public:
     ServerSocket( int port);
Index: branches/new_class_id/src/lib/network/shared_network_data.cc
===================================================================
--- branches/new_class_id/src/lib/network/shared_network_data.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/shared_network_data.cc	(revision 9690)
@@ -25,5 +25,5 @@
 
 
-
+NewObjectListDefinition(SharedNetworkData);
 SharedNetworkData* SharedNetworkData::singletonRef = NULL;
 
Index: branches/new_class_id/src/lib/network/shared_network_data.h
===================================================================
--- branches/new_class_id/src/lib/network/shared_network_data.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/shared_network_data.h	(revision 9690)
@@ -22,5 +22,5 @@
 class SharedNetworkData : public BaseObject
 {
-
+  NewObjectListDeclaration(SharedNetworkData);
   public:
     inline static SharedNetworkData* getInstance() { if (!SharedNetworkData::singletonRef) SharedNetworkData::singletonRef = new SharedNetworkData();
Index: branches/new_class_id/src/lib/network/synchronizeable.cc
===================================================================
--- branches/new_class_id/src/lib/network/synchronizeable.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/synchronizeable.cc	(revision 9690)
@@ -32,4 +32,5 @@
 
 
+NewObjectListDefinition(Synchronizeable);
 
 /**
@@ -38,5 +39,5 @@
 Synchronizeable::Synchronizeable()
 {
-  this->setClassID(CL_SYNCHRONIZEABLE, "Synchronizeable");
+  this->registerObject(this, Synchronizeable::_objectList);
   this->owner = 0;
 //   this->setIsServer(SharedNetworkData::getInstance()->getHostID() == 0);
Index: branches/new_class_id/src/lib/network/synchronizeable.h
===================================================================
--- branches/new_class_id/src/lib/network/synchronizeable.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/synchronizeable.h	(revision 9690)
@@ -41,4 +41,5 @@
 class Synchronizeable : virtual public BaseObject
 {
+  NewObjectListDeclaration(Synchronizeable);
 
   public:
Index: branches/new_class_id/src/lib/network/tcp_server_socket.cc
===================================================================
--- branches/new_class_id/src/lib/network/tcp_server_socket.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/tcp_server_socket.cc	(revision 9690)
@@ -26,4 +26,5 @@
 #include "debug.h"
 
+NewObjectListDefinition(TcpServerSocket);
 TcpServerSocket::TcpServerSocket( int port ) : ServerSocket( port )
 {
Index: branches/new_class_id/src/lib/network/tcp_server_socket.h
===================================================================
--- branches/new_class_id/src/lib/network/tcp_server_socket.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/tcp_server_socket.h	(revision 9690)
@@ -19,4 +19,5 @@
 class TcpServerSocket : public ServerSocket
 {
+  NewObjectListDeclaration(TcpServerSocket);
   public:
     TcpServerSocket( int port );
Index: branches/new_class_id/src/lib/network/tcp_socket.cc
===================================================================
--- branches/new_class_id/src/lib/network/tcp_socket.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/tcp_socket.cc	(revision 9690)
@@ -30,4 +30,5 @@
 #include "debug.h"
 
+NewObjectListDefinition(TcpSocket);
 /**
  * Default constructor
@@ -122,7 +123,7 @@
 {
   IPaddress ip;
-  
-  bOk = true; 
-  
+
+  bOk = true;
+
   if ( SDLNet_ResolveHost( &ip, host.c_str(), port ) != 0 )
   {
@@ -131,5 +132,5 @@
     return;
   }
-  
+
   //check if not already connected or listening
   if (tcpSocket)
@@ -345,7 +346,7 @@
 }
 #endif
-  
+
   PRINTF(0)("QUIT READ THREAD\n");
-  
+
   return 0;
 }
@@ -425,5 +426,5 @@
 
   return 0;
-  
+
 }
 
Index: branches/new_class_id/src/lib/network/tcp_socket.h
===================================================================
--- branches/new_class_id/src/lib/network/tcp_socket.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/tcp_socket.h	(revision 9690)
@@ -40,4 +40,5 @@
 class TcpSocket : public NetworkSocket
 {
+  NewObjectListDeclaration(TcpSocket);
   public:
     TcpSocket();
Index: branches/new_class_id/src/lib/network/udp_broadcast.cc
===================================================================
--- branches/new_class_id/src/lib/network/udp_broadcast.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/udp_broadcast.cc	(revision 9690)
@@ -18,4 +18,5 @@
 #include "udp_broadcast.h"
 
+NewObjectListDefinition(UdpBroadcast);
 /**
  * standard constructor
@@ -26,11 +27,11 @@
   this->port = 0;
   packet = SDLNet_AllocPacket( BROADCAST_PACKET_SIZE );
-  
-  if ( !packet ) 
+
+  if ( !packet )
   {
     printf( "SDLNet_AllocPacket: %s\n", SDLNet_GetError() );
     assert( packet );
   }
-  
+
   this->socket = NULL;
 }
@@ -47,5 +48,5 @@
     this->packet = NULL;
   }
-  
+
   if ( this->socket )
   {
@@ -53,10 +54,10 @@
     this->socket = NULL;
   }
-  
+
 }
 
 /**
  * listen for incoming broadcast packets
- * @param port port to listen on 
+ * @param port port to listen on
  * @return true on success
  */
@@ -74,5 +75,5 @@
 {
   this->port = port;
-  
+
   return true;
 }
@@ -80,5 +81,5 @@
 /**
  * send packet
- * @param data data to send 
+ * @param data data to send
  * @param length length of data
  * @param ip if ip == NULL broadcast is used
Index: branches/new_class_id/src/lib/network/udp_broadcast.h
===================================================================
--- branches/new_class_id/src/lib/network/udp_broadcast.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/udp_broadcast.h	(revision 9690)
@@ -15,9 +15,9 @@
 class UdpBroadcast
 {
-
+  NewObjectListDeclaration(UdpBroadcast);
   public:
     UdpBroadcast();
     virtual ~UdpBroadcast();
-    
+
     bool listen( int port );
     bool open( int port );
Index: branches/new_class_id/src/lib/network/udp_server_socket.cc
===================================================================
--- branches/new_class_id/src/lib/network/udp_server_socket.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/udp_server_socket.cc	(revision 9690)
@@ -18,5 +18,5 @@
 
 
-
+NewObjectListDefinition(UdpServerSocket);
 /**
  * constructor
Index: branches/new_class_id/src/lib/network/udp_server_socket.h
===================================================================
--- branches/new_class_id/src/lib/network/udp_server_socket.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/udp_server_socket.h	(revision 9690)
@@ -50,4 +50,5 @@
 class UdpServerSocket : public ServerSocket
 {
+  NewObjectListDeclaration(UdpServerSocket);
   public:
     UdpServerSocket( int port);
Index: branches/new_class_id/src/lib/network/udp_socket.cc
===================================================================
--- branches/new_class_id/src/lib/network/udp_socket.cc	(revision 9683)
+++ branches/new_class_id/src/lib/network/udp_socket.cc	(revision 9690)
@@ -18,4 +18,5 @@
 #include "debug.h"
 
+NewObjectListDefinition(UdpSocket);
 
 void UdpSocket::init( )
Index: branches/new_class_id/src/lib/network/udp_socket.h
===================================================================
--- branches/new_class_id/src/lib/network/udp_socket.h	(revision 9683)
+++ branches/new_class_id/src/lib/network/udp_socket.h	(revision 9690)
@@ -24,4 +24,5 @@
 class UdpSocket : public NetworkSocket
 {
+  NewObjectListDeclaration(UdpSocket);
   public:
     UdpSocket();