Index: branches/new_class_id/src/lib/coord/p_node.h
===================================================================
--- branches/new_class_id/src/lib/coord/p_node.h	(revision 9684)
+++ branches/new_class_id/src/lib/coord/p_node.h	(revision 9691)
@@ -50,5 +50,5 @@
   PNODE_REPARENT_DELETE_CHILDREN       = 0x0040,    //!< Deletes the Children of the node when This Node is Removed. (Use with care).
   /// FIXME
-   PNODE_REPARENT_KEEP_POSITION         = 0x0080,    //!< Tries to keep the Position if the Node is reparented.
+  PNODE_REPARENT_KEEP_POSITION         = 0x0080,    //!< Tries to keep the Position if the Node is reparented.
 
 
@@ -73,8 +73,9 @@
 
 //! Patent Node is a Engine to calculate the position of an Object in respect to the position of its parent.
-class PNode : virtual public BaseObject, virtual public Synchronizeable {
+class PNode : virtual public BaseObject, virtual public Synchronizeable
+{
   NewObjectListDeclaration(PNode);
 
-  public:
+public:
   PNode (PNode* parent = PNode::getNullParent(), long nodeFlags = PNODE_PARENT_MODE_DEFAULT);
   virtual ~PNode ();
@@ -97,5 +98,5 @@
   inline const Vector& getRelCoor () const { return this->prevRelCoordinate; };
   /** @returns the Relative Coordinate Destination */
-  inline const Vector& getRelCoorSoft2D() const { return (this->toCoordinate)? *this->toCoordinate : this->relCoordinate; };
+inline const Vector& getRelCoorSoft2D() const { return (this->toCoordinate)? *this->toCoordinate : this->relCoordinate; };
   void setAbsCoor (const Vector& absCoord);
   void setAbsCoor (float x, float y, float z);
@@ -132,5 +133,5 @@
   inline const Quaternion& getRelDir () const { return this->prevRelDirection; };
   /** @returns the Relative Directional Destination */
-  inline const Quaternion& getRelDirSoft2D() const { return (this->toDirection)? *this->toDirection : this->relDirection; };
+inline const Quaternion& getRelDirSoft2D() const { return (this->toDirection)? *this->toDirection : this->relDirection; };
   /** @returns a Vector pointing into the relative Direction */
   inline Vector getRelDirV() const { return this->prevRelDirection.apply(Vector(0,1,0)); };
@@ -180,7 +181,6 @@
   void removeNodeFlags(unsigned short nodeFlags);
 
-  // NULL_PARENT //
   /** @returns the NullParent, the (main) ROOT of the PNode Tree. If it does not yet exist, it will be created. */
-  static PNode* getNullParent()  { return (PNode::nullParent != NULL)? PNode::nullParent : PNode::createNullParent(); };
+static PNode* getNullParent()  { return (PNode::nullParent != NULL) ? PNode::nullParent : PNode::createNullParent(); };
 
   // UPDATING //
@@ -197,13 +197,13 @@
   float distance(const PNode* node) const { return (this->getAbsCoor() - node->getAbsCoor()).len(); };
 
- private:
+private:
   /** tells the child that the parent's Coordinate has changed */
   inline void parentCoorChanged () { this->bRelCoorChanged = true; }
   /** tells the child that the parent's Direction has changed */
   inline void parentDirChanged () { this->bRelDirChanged = true; }
- public:
+public:
   /** @returns the last calculated coordinate */
   inline Vector getLastAbsCoor() { return this->lastAbsCoordinate; }
- private:
+private:
   static PNode* createNullParent();
   void reparent();
@@ -211,5 +211,5 @@
   void eraseChild(PNode* child);
 
- private:
+private:
   bool               bRelCoorChanged;    //!< If Relative Coordinate has changed since last time we checked
   bool               bRelDirChanged;     //!< If Relative Direction has changed since last time we checked
@@ -223,5 +223,5 @@
   Vector             lastAbsCoordinate;  //!< this is used for speedcalculation, it stores the last coordinate
   Quaternion         prevRelDirection;   //!< The last Relative Direciton from the last update-Cycle.
-//  Quaternion         lastAbsDirection;
+  //  Quaternion         lastAbsDirection;
 
   Vector             velocity;           //!< Saves the velocity.
@@ -240,23 +240,32 @@
   static PNode*      nullParent;         //!< The ROOT of the main PNode Tree.
 
-  private:
-    float coorx;
-    float coory;
-    float coorz;
-
-    float rotw;
-    float rotx;
-    float roty;
-    float rotz;
-
-  private:
-    int relCoordinate_handle;
-    int relDirection_handle;
-    Vector relCoordinate_write;
-    Quaternion relDirection_write;
-
-  public:
-    virtual void varChangeHandler( std::list<int> & id );
+private:
+  float coorx;
+  float coory;
+  float coorz;
+
+  float rotw;
+  float rotx;
+  float roty;
+  float rotz;
+
+private:
+  int relCoordinate_handle;
+  int relDirection_handle;
+  Vector relCoordinate_write;
+  Quaternion relDirection_write;
+
+public:
+  virtual void varChangeHandler( std::list<int> & id );
 };
 
+// NULL_PARENT //
+class NullParent : public PNode
+{
+  NewObjectListDeclaration(NullParent);
+  friend class PNode;
+  NullParent();
+};
+
+
 #endif /* _P_NODE_H */